using System;
using System.Collections.Generic;
using System.Text;

namespace IgraMemo
{
    class Program
    {
        static void Main(string[] args)
        {
            String zmagovalnaKombinacija = nakljucnaKombinacija();
            int steviloPoskusov = 0;
            // igralec ima na razpolago najvec 6 moznosti
            while (steviloPoskusov < 6)
            {
                Console.WriteLine("Vnesi stirimestno kombinacijo\n"
                                + "(Y – rumena, O – oranzna, R – rdeca, B – modra, G – zelena, V - vijolicna):");
                String beri = Console.ReadLine();

                // primerjamo vneseno kombinacijo z nakljucno in izpisemo rezultat
                Console.WriteLine(beri);
                String primerjava = odgovorPrimerjave(beri, zmagovalnaKombinacija);
                Console.WriteLine(primerjava);
                Console.WriteLine();

                // ce je kombinacija zmagovalna, koncamo
                if (primerjava.Equals("BBBB"))
                {
                    Console.WriteLine("Zmagal si!");
                    break;
                }
                steviloPoskusov = steviloPoskusov + 1;
            }
            // ce smo porabili vse poskuse
            if (steviloPoskusov == 6)
            {
                Console.WriteLine("Izgubil si.");
            }
            Console.ReadKey();
        }

        // metoda, ki generira nakljucno kombinacijo stirih razlicnih znakov
        public static String nakljucnaKombinacija()
        {
            char[] barve = { 'Y', 'O', 'R', 'B', 'G', 'V' };
            String kombinacija = "";

            // sestavimo kombinacijo znakov
            for (int i = 0; i < 4; ++i)
            {
                // izberemo nakljucno barvo (med se ne izbranimi) in jo dodamo h
                // kombinaciji. Izbiramo med prvimi (6-i). barvami
                Random random = new Random();
                int mestoBarve = random.Next(0, 6 - i);
                kombinacija += barve[mestoBarve];

                // barvo, ki smo jo izbrali, izvzamemo iz nadaljnjih izbiranj
		barve[mestoBarve] = barve[5 - i];
            }
            return kombinacija;
        }

        // metoda, ki primerja dva niza
        public static String odgovorPrimerjave(String igralcevNiz,
                String zmagovalniNiz)
        {
            String odg = "";
            for (int i = 0; i < 4; ++i)
            {
                // ce sta barva in lega enaki
                if (igralcevNiz[i] == zmagovalniNiz[i])
                {
                    odg = odg + 'B';
                }
                // ce se barva nahaja v zmagovalnem nizu, pa ni na pravem mestu
                else if (zmagovalniNiz.IndexOf(igralcevNiz[i]) != -1)
                {
                    odg = odg + 'W';
                }
                // barve ni v zmagovalnem nizu
                else
                {
                    odg = odg + " ";
                }
            }
            return odg;
        }
    }
}
